/* Binarna pretraga niza celih brojeva - iterativna verzija*/
#include <stdio.h>

/* Funkcija proverava da li se element x javlja unutar niza 
   celih brojeva a.
   Funkcija vraca poziciju na kojoj je element nadjen odnosno
   -1 ako ga nema.
 
   !!!!! VAZNO !!!!!
   Pretpostavka je da je niz a uredjen po velicini
*/

int binary_search(int a[], int n, int x)
{
	/* Pretrazujemo interval [l, d] */
	int l = 0;
	int d = n-1;
	
	/* Sve dok interval [l, d] nije prazan */
	while (l <= d)
	{
		/* Srednja pozicija intervala [l, d] */
		int s = (l+d)/2;
		
		/* Ispitujemo odnos x-a i srednjeg elementa */
		if (x == a[s])
			/* Element je pronadjen */
			return s;
		else if (x < a[s])
		{
			/* Pretrazujemo interval [l, s-1] */	
			d = s-1;
		}
		else
		{
			/* Pretrazujemo interval [s+1, d] */
			l = s+1;
		}
	}

	/* Element je nadjen */
	return -1;	
}

main()
{
	int a[] = {3, 5, 7, 9, 11, 13, 15};
	int x;
	int i;
		
	printf("Unesi element kojega trazimo : ");
	scanf("%d",&x);
	i = binary_search(a, sizeof(a)/sizeof(int), x);
	
	if (i==-1)
		printf("Elementa %d nema\n", x);
	else
		printf("Pronadjen na poziciji %d\n", i);
}
