/* print_bits - stampa bitove u zapisu datog celog broja x. */

#include <stdio.h>

/* Funkcija stampa bitove datog celog broja x. 
   Vrednost bita na poziciji i je 0 ako i samo ako se pri konjunkciji broja x sa maskom 
   000..010....000 - sve 0 osim 1 na poziciji i, dobija 0.
   Funkcija krece od pozicije najvece tezine kreirajuci masku pomeranjem jedinice u levo 
   za duzina(x) - 1 mesto, i zatim pomerajuci ovu masku za jedno mesto u levo u svakoj 
   sledecoj iteraciji sve dok maska ne postane 0.
*/

void print_bits(int x)
{
	/* Broj bitova tipa unsigned */
	int wl = sizeof(int)*8;
	
	unsigned mask;
	for (mask = 1<<wl-1; mask; mask >>= 1)
		putchar(x&mask ? '1' : '0');
		
	putchar('\n');
}


main()
{
	print_bits(127);
	print_bits(128);
	print_bits(0x00FF00FF);
	print_bits(0xFFFFFFFF);
}
