/* sum_of_bits - izracunava sumu bitova datog neoznacenog broja */

#include <stdio.h>

int sum_of_bits(unsigned x)
{
	/* Broj bitova tipa unsigned */
	int wl = sizeof(unsigned)*8;
	int br = 0;
	
	unsigned mask;	
	for (mask = 1<<wl-1; mask; mask>>=1)
		if (x&mask)
			br++;
	
	return br;
}

/* Efikasnija verzija */
int sum_of_bits(unsigned x)
{
	int br;
	for (br = 0; x; x>>=1)
		if (x&1)
			br++;
	
	return br;
}


main()
{
	printf("%d\n",sum_of_bits(127));
	printf("%d\n",sum_of_bits(128));
	printf("%d\n",sum_of_bits(0x00FF00FF));
	printf("%d\n",sum_of_bits(0xFFFFFFFF));
}
