/* Program demonstrira niz kome se velicina tokom rada povecava 
   - verzija sa rucnom realokacijom */

#include <stdio.h>
#include <stdlib.h>

/* Niz ce se uvecavati u koracima od po 10 brojeva */
#define KORAK 10

int main()
{
	/* Niz je u pocetku prazan */
	int* a = NULL;

	/* duzina predstavlja broj popunjenih elemenata, 
	   dok alocirano predstavlja broj alociranih elemenata */
	int duzina = 0, alocirano = 0;
	int n, i;


	do
	{
		printf("Unesi ceo broj (-1 za kraj): ");
		scanf("%d", &n);
		/* Ukoliko nema vise slobodnih mesta, vrsi se prosirivanje */
		if (duzina == alocirano)
		{
			/* Kreira se novi niz */
			int* new_a;
			
			/* Za njega se alocira 10 elemenata vise od prethodnog */
			alocirano = alocirano + KORAK;
			new_a = malloc(alocirano*sizeof(int));

			/* Kopira se sadrzaj starog niza u novi */
			for (i = 0; i<duzina; i++)
				new_a[i] = a[i];

			/* Oslobadja se stari niz */
			free(a);

			/* Stari niz postaje novi */
			a = new_a;
		}

		/* Ucitani broj se upisuje u niz */
		a[duzina++] = n;

	} while (n != -1);

	/* Ispisujemo niz a */
	printf("Uneto je %d brojeva. Alocirano je ukupno %d bajtova\n", 
		duzina, alocirano*sizeof(int));
	printf("Brojevi su : ");
	for (i = 0; i<duzina; i++)
		printf("%d ", a[i]);

	/* Oslobadjamo niz a */
	free(a);

	return 0;
}

