/* Binarna pretraga niza celih brojeva - rekurzivna verzija*/
#include <stdio.h>

/* Funkcija proverava da li se element x javlja unutar niza 
   celih brojeva a.
   Funkcija vraca poziciju na kojoj je element nadjen odnosno
   -1 ako ga nema.
 
   !!!!! VAZNO !!!!!
   Pretpostavka je da je niz a uredjen po velicini
*/

int binary_search(int a[], int l, int d, int x)
{
	/* Ukoliko je interval prazan, elementa nema */
	if (l > d)
		return -1;

	
	/* Srednja pozicija intervala [l, d] */
	int s = (l+d)/2;
		
	/* Ispitujemo odnos x-a i srednjeg elementa */
	if (x == a[s])
		/* Element je pronadjen */
		return s;
	else if (x < a[s])
		/* Pretrazujemo interval [l, s-1] */
		return 	binary_search(a, l, s-1, x);
	else
		/* Pretrazujemo interval [s+1, d] */
		return 	binary_search(a, s+1, d, x);
}

main()
{
	int a[] = {3, 5, 7, 9, 11, 13, 15};
	int x;
	int i;
		
	printf("Unesi element kojega trazimo : ");
	scanf("%d",&x);
	i = binary_search(a, 0, sizeof(a)/sizeof(int)-1, x);
	
	if (i==-1)
		printf("Elementa %d nema\n", x);
	else
		printf("Pronadjen na poziciji %d\n", i);
}
