/* Sortiranje niza reci - leksikografski odnosno po duzini - koriscenje 
   ugradjene qsort funkcije*/ 

#include <stdlib.h>
#include <string.h>

/* Funkcija koja vrsi leksikografsko poredjenje dve reci */
int lexicographic_compare(const void* a, const void* b)
{    return strcmp(*(char**)a,*(char**)b);   }

/* Funkcija koja vrsi poredjenje po duzini dve reci, opadajuce*/
int length_compare(const void* a, const void* b)
{     return strlen(*(char**)b)-strlen(*(char**)a);	}


main()
{
	int i;
	char* a[] = {"Jabuka", "Kruska", "Sljiva", "Dinja", "Lubenica"};
	int n = sizeof(a)/sizeof(int);

	/* Sortiramo leksikografski i ispisujemo rezultat */	
	qsort((void*)a, n, sizeof(char*), &lexicographic_compare);
	for (i=0; i<n; i++)
		printf("%s ", a[i]);
	putchar('\n');


	/* Sortiramo po duzini i ispisujemo rezultat */	
	qsort((void*)a, n, sizeof(char*), &length_compare);
	for (i=0; i<n; i++)
		printf("%s ", a[i]);
	putchar('\n');


}
