/* power - funkcija koja stepenuje realan broj na celobrojni izlozilac */
#include <stdio.h>

/* stepenuje x^k tako sto k puta pomnozi x */
int power(float x, int k)
{
	int i;
	float s = 1;
	for (i = 0; i<k; i++)
		s*=x;
	
	return s;
}

/* Verzija koja radi i za negativne izlozioce */
int power_n(float x, int k)
{
	int i;
	int negative = k<0;

	if (negative)
		k = -k;

	float s = 1;
	for (i = 0; i<k; i++)
		s*=x;
	
	return negative ? 1.0/s : s;	
}

main()
{
	/* Poziv funkcije */
	float s = power(2.0,8);
	printf("%f\n", s);
}
