/* atoi - konverzija niske cifara u brojnu vrednost */
/* Program omogucuje citanje celog broja bez koriscenja funkcije scanf("%d")
   Napomena : funkcija atoi vec postoji u zaglavlju <stdio.h> i ovde 
   je implementirana samo za vezbu 
*/

#include <stdio.h>
#include <ctype.h> /* Zbog funkcije isspace */

/* Maksimalna duzina reci */
#define MAX_DIGITS 10


/* AsciiTOInteger
   Funkcija izracunava vrednost celog broja koji je zapisan u datom 
   nizu karaktera. Za izracunavanje se koristi Hornerova shema. */
   
int atoi(char s[])
{
	int sum = 0;
	
	/* Obradjuju se karakteri sve dok su cifre */
	int i;
	for (i = 0; isdigit(s[i]); i++)
		sum = 10*sum + (s[i]-'0');
		
	return sum;
}


main()
{
	char s[MAX_DIGITS];
	int num;
	
	/* Ucitavamo broj u vidu niske karaktera */
	printf("Unesi ceo broj : ");

	/* Obratiti paznju da uz s ne stoji & */
	scanf("%s", s);

	/* Izracunava se njegova vrednost */
	num  = atoi(s);
	
	/* Ispisuje se vrednost */
	printf("Uneo si broj : %d\n", num);
	printf("Broj za tri veci je : %d\n",  num+3);
	
}

