/* Program demonstrira niz kome se velicina tokom rada povecava 
   - verzija sa funkcijom realloc */

#include <stdio.h>
#include <stdlib.h>

#define KORAK 10
int main()
{
	/* Niz je u pocetku prazan */
	int* a = NULL;

	/* duzina predstavlja broj popunjenih elemenata, 
       dok alocirano predstavlja broj alociranih elemenata */
	int duzina = 0, alocirano = 0;

	int n, i;


	do
	{
		printf("Unesi ceo broj (-1 za kraj): ");
		scanf("%d", &n);
		/* Ukoliko nema vise slobodnih mesta, vrsi se prosirivanje */
		if (duzina == alocirano)
		{
			/* Niz se prosiruje na 10 elemenata vise */
			alocirano = alocirano + KORAK;
			a = realloc(a, alocirano*sizeof(int));
		}
		a[duzina++] = n;

	} while (n != -1);

	/* Ispisujemo niz a */
	printf("Uneto je %d brojeva. Alocirano je ukupno %d bajtova\n", 
		duzina, alocirano*sizeof(int));
	printf("Brojevi su : ");
	for (i = 0; i<duzina; i++)
		printf("%d ", a[i]);

	/* Oslobadjamo niz a */
	free(a);

	return 0;
}

